/* ⣺ */
/*
   1    SetCursorShape      ù״        AH=01H
   2    GotoXY              ùλ        AH=02H
   3    SaveCursor          λ/״     AH=03H
   4    EnableCursor        ʾ        AX=FF01H,BL=01H
   5    DisableCursor       ֹʾ        ..
   6    GetCursorStatus     Ƿ      AX=FF01H,BL=11H
   7    EnableGraphCursor   ͼģʽ    AX=FF01H,BL=02H
   8    DisableGraphCursor  ֹͼģʽ    ..
   9    GetCursorBlinkTime  ˸      AX=FF01H,BL=10H
  10    SetCursorBlinkTime  ù˸      AX=FF01H,BL=00H
*/
#include                "dos.h"
#include                "stdio.h"

typedef                 unsigned char   BYTE;
typedef                 unsigned int    WORD;

void SetCursorShape(int FirstLine,int LastLine)
{
   union REGS regs;

   regs.h.ah = 1;
   regs.h.ch = FirstLine;
   regs.h.cl = LastLine;
   int86(0x10,&regs,&regs);

}

void GotoXY(int Row,int Col)
{
   union REGS regs;

   regs.h.ah = 2;
   regs.h.bh = 0;
   regs.h.dh = Row;
   regs.h.dl = Col;
   int86(0x10,&regs,&regs);
}

void SaveCursor(int * Row, int * Col, int * FirstLine, int * LastLine)
{
   union REGS regs;

   regs.h.ah = 3;
   int86(0x10,&regs,&regs);
   *Row = (int)regs.h.dh;
   *Col = (int)regs.h.dl;
   *FirstLine = (int)regs.h.ch;
   *LastLine = (int)regs.h.cl;
}

void EnableCursor(void)
{
   union REGS regs;

   regs.x.ax = 0xff01;
   regs.h.bl = 1;
   regs.h.bh = 1;
   int86(0x10,&regs,&regs);
}

void DisableCursor(void)
{
   union REGS regs;

   regs.x.ax = 0xff01;
   regs.h.bl = 1;
   regs.h.bh = 0;
   int86(0x10,&regs,&regs);
}

int GetCursorStatus(void)
{
   union REGS regs;

   regs.x.ax = 0xff01;
   regs.h.bl = 0x11;
   int86(0x10,&regs,&regs);
   return regs.h.al;
}

void EnableGraphCursor(void)
{
   union REGS regs;

   regs.x.ax = 0xff01;
   regs.h.bl = 2;
   regs.h.bh = 1;
   int86(0x10,&regs,&regs);
}

void DisableGraphCursor(void)
{
   union REGS regs;

   regs.x.ax = 0xff01;
   regs.h.bl = 2;
   regs.h.bh = 0;
   int86(0x10,&regs,&regs);
}

int GetCursorBlinkTime(void)
{
   union REGS regs;

   regs.x.ax = 0xff01;
   regs.h.bl = 0x10;
   int86(0x10,&regs,&regs);
   return regs.h.al;
}

void SetCursorBlinkTime(int BlinkCount)
{
   union REGS regs;

   regs.x.ax = 0xff01;
   regs.h.bl = 0x00;
   regs.h.bh = BlinkCount;
   int86(0x10,&regs,&regs);
}

void SetDisplayMode(BYTE Mode)
{
   union REGS regs;

   regs.h.ah = 0;
   regs.h.al = Mode;
   int86(0x10,&regs,&regs);
}

void main()
{
   int          SaveCursorEnable;
   int          x,y,BeginLine,EndLine;
   int          CurBlinkTime;
   char         ch;

   SetDisplayMode(0x3);
   GotoXY(2,0);
   SaveCursorEnable = GetCursorStatus();
   EnableCursor();
   SetCursorShape(0x6,0x7);
   printf("괦״̬رչ\n");
   getch();
   DisableCursor();
   printf("걻رգ\n");
   getch();
   EnableCursor();
   SaveCursor(&x,&y,&BeginLine,&EndLine);
   printf("ʼɨ = %d, ɨ = %d\n",BeginLine,EndLine);
   printf("ùΪ\n");
   getch();
   SetCursorShape(0x0,0x7);
   printf("ָΪС\n");
   getch();
   SetCursorShape(0x6,0x7);
   SetCursorBlinkTime(8);
   CurBlinkTime = GetCursorBlinkTime();
   printf("ǰ˸Ϊ %d,ֹ˸\n",CurBlinkTime);
   getch();
   SetCursorBlinkTime(0);
   printf("ͼηʽùΪ״̬\n");
   getch();
   SetCursorBlinkTime(3);
   SetDisplayMode(0x12);
   EnableGraphCursor();
   printf("ֹʾ\n");
   getch();
   DisableGraphCursor();
   printf("˳\n");
   getch();
   SetDisplayMode(0x3);
   if (SaveCursorEnable == 0) DisableCursor();
}
